## libinstpatch 1.1.7

=== CMakeLists.txt ===
# 
# libInstPatch
#
# Copyright (C) 1999-2014 Element Green <element@elementsofsound.org>
#
# See COPYING license file for distribution details
#

cmake_minimum_required ( VERSION 3.6 )
project ( libInstPatch C )

set ( CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake )

# libInstPatch package name
set ( PACKAGE "libinstpatch" )

# libInstPatch package version
set ( IPATCH_VERSION_MAJOR 1 )
set ( IPATCH_VERSION_MINOR 1 )
set ( IPATCH_VERSION_MICRO 7 )
set ( VERSION "${IPATCH_VERSION_MAJOR}.${IPATCH_VERSION_MINOR}.${IPATCH_VERSION_MICRO}" )
set ( IPATCH_VERSION "\"${VERSION}\"" )

# libinstpatch - Library version
# *** NOTICE ***
# Update library version upon each release (follow these steps in order)
# if any source code changes: REVISION++
# if any interfaces added/removed/changed: REVISION=0
# if any interfaces removed/changed (compatibility broken): CURRENT++
# if any interfaces have been added: AGE++
# if any interfaces have been removed/changed (compatibility broken): AGE=0
# This is not exactly the same algorithm as the libtool one, but the results are the same.
set ( LIB_VERSION_CURRENT 2 )
set ( LIB_VERSION_AGE 2 )
set ( LIB_VERSION_REVISION 1 )
set ( LIB_VERSION_INFO 
      "${LIB_VERSION_CURRENT}.${LIB_VERSION_AGE}.${LIB_VERSION_REVISION}" )

# Options disabled by default
option ( enable-debug "enable debugging (default=no)" off )
option ( GTKDOC_ENABLED "Create Gtk-Doc API reference (default=no)" off )
option ( INTROSPECTION_ENABLED "Create GObject Introspection typelib" off )

# Options enabled by default
option ( BUILD_SHARED_LIBS "Build a shared object or DLL" on )

# Initialize the library directory name suffix.
if ( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  set ( _init_lib_suffix "64" )
else ( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  set ( _init_lib_suffix "" )
endif ( CMAKE_SIZEOF_VOID_P EQUAL 8 )

# Sane defaults for CMAKE_INSTALL_*
include ( GNUInstallDirs )

# Default install directory names
include ( DefaultDirs )

# Basic C library checks
include ( CheckSTDC )
include ( CheckIncludeFile )
check_include_file ( string.h HAVE_STRING_H )
check_include_file ( stdlib.h HAVE_STDLIB_H )
check_include_file ( stdio.h HAVE_STDIO_H )
check_include_file ( math.h HAVE_MATH_H )
check_include_file ( errno.h HAVE_ERRNO_H )
check_include_file ( stdarg.h HAVE_STDARG_H )
check_include_file ( unistd.h HAVE_UNISTD_H )
check_include_file ( locale.h HAVE_LOCALE_H )
check_include_file ( xlocale.h HAVE_XLOCALE_H )

if ( WIN32 )
  # Check presence of MS include files
  check_include_file ( io.h HAVE_IO_H )
endif( WIN32 )


unset ( IPATCH_CPPFLAGS CACHE )
unset ( IPATCH_LIBS CACHE )

# Options for the GNU C compiler only
if ( CMAKE_COMPILER_IS_GNUCC )
  if ( NOT APPLE )
    set ( CMAKE_EXE_LINKER_FLAGS 
          "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed" )
    set ( CMAKE_SHARED_LINKER_FLAGS 
          "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined" )
  endif ( NOT APPLE )
  set ( GNUCC_WARNING_FLAGS "-Wall")
  set ( CMAKE_C_FLAGS "-pedantic ${CMAKE_C_FLAGS}" )
  set ( CMAKE_C_FLAGS_DEBUG "-g -DDEBUG -fsanitize=undefined ${GNUCC_WARNING_FLAGS} ${CMAKE_C_FLAGS_DEBUG}" )
  set ( CMAKE_C_FLAGS_RELEASE "-O2 -DNDEBUG ${GNUCC_WARNING_FLAGS} ${CMAKE_C_FLAGS_RELEASE}" )
  set ( CMAKE_C_FLAGS_RELWITHDEBINFO "-O2 -g -DNDEBUG ${GNUCC_WARNING_FLAGS} ${CMAKE_C_FLAGS_RELWITHDEBINFO}" )
endif ( CMAKE_COMPILER_IS_GNUCC )

if ( MSVC )
    # statically link in the CRT library to avoid a bunch of runtime DLL dependencies and allow 
    # the CI windows builds to be run under WinXP
    foreach ( flag_var
        CMAKE_C_FLAGS
        CMAKE_C_FLAGS_DEBUG
        CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL
        CMAKE_C_FLAGS_RELWITHDEBINFO
        CMAKE_CXX_FLAGS
        CMAKE_CXX_FLAGS_DEBUG
        CMAKE_CXX_FLAGS_RELEASE
        CMAKE_CXX_FLAGS_MINSIZEREL
        CMAKE_CXX_FLAGS_RELWITHDEBINFO
        )
      if ( ${flag_var} MATCHES "/MD" )
        string ( REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}" )
      endif ( ${flag_var} MATCHES "/MD" )
    endforeach ( flag_var )
endif ( MSVC )

if ( enable-debug )  
    set ( CMAKE_BUILD_TYPE "Debug" CACHE STRING
          "Choose the build type, options: Debug Release RelWithDebInfo" FORCE )
    set ( IPATCH_DEBUG 1 )
endif ( enable-debug )

unset ( MINGW32 CACHE )
if ( WIN32 )
  # MinGW compiler (a Windows GCC port)
  if ( MINGW ) 
    set ( MINGW32 1 )
    add_definitions ( -mms-bitfields )
  endif  ( MINGW )
else ( WIN32 )
  set ( IPATCH_LIBS "m" )
endif ( WIN32 )

unset ( ENABLE_DEBUG CACHE )
unset ( DEBUG CACHE )
if ( CMAKE_BUILD_TYPE MATCHES "Debug" )
    set ( ENABLE_DEBUG 1 )
    set ( DEBUG 1 )
endif ( CMAKE_BUILD_TYPE MATCHES "Debug" )

# Mandatory tool: pkg-config
find_package ( PkgConfig REQUIRED )

# Mandatory libraries: gobject, glib and gthread
pkg_check_modules ( GOBJECT REQUIRED gobject-2.0>=2.12 glib-2.0>=2.12 gthread-2.0>=2.12 )

# Disable deprecation warnings for now (fixed in master)
add_definitions ( -DGLIB_DISABLE_DEPRECATION_WARNINGS )

include ( UnsetPkgConfig )

# Check for libsndfile
find_package ( SndFile 1.2.1 )
if ( NOT SNDFILE_FOUND )
  pkg_check_modules ( SNDFILE REQUIRED sndfile>=1.2.1 )
endif()

# Check for GObjectIntrospection binding
if (INTROSPECTION_ENABLED)
  include (FindGObjectIntrospection)
endif ()

# Check for Gtk-Doc
if (GTKDOC_ENABLED)
  find_package(GtkDoc)
endif ()

# General configuration file
configure_file ( ${CMAKE_SOURCE_DIR}/config.h.cmake 
                 ${CMAKE_BINARY_DIR}/config.h )
add_definitions ( -DHAVE_CONFIG_H )

# Version and master libinstpatch.h file
configure_file ( ${CMAKE_SOURCE_DIR}/libinstpatch/version.h.in
                 ${CMAKE_CURRENT_BINARY_DIR}/libinstpatch/version.h )
configure_file ( ${CMAKE_SOURCE_DIR}/libinstpatch/libinstpatch.h.in
                 ${CMAKE_CURRENT_BINARY_DIR}/libinstpatch/libinstpatch.h )

set (INSTPATCH_INSTALL_TARGET "libinstpatch-${LIB_VERSION_CURRENT}")

# pkg-config support
if ( UNIX OR MINGW OR WIN32)
    # stamp library name with version current value (for Windows only)
    if(MINGW OR WIN32)
        set ( lib_version_suffix ${LIB_VERSION_CURRENT} )
    else(MINGW OR WIN32)
        set ( lib_version_suffix 1.0 )
    endif(MINGW OR WIN32)
    configure_file ( libinstpatch-1.0.pc.in
        ${CMAKE_BINARY_DIR}/libinstpatch-1.0.pc IMMEDIATE @ONLY )
    install ( FILES ${CMAKE_BINARY_DIR}/libinstpatch-1.0.pc
              DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig )
endif ( UNIX OR MINGW OR WIN32)

# Extra targets for Unix build environments
if ( UNIX )
    # uninstall custom target
    configure_file ( "${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake" IMMEDIATE @ONLY)
    add_custom_target ( uninstall
      "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif ( UNIX )

# Process subdirectories 
add_subdirectory ( libinstpatch )
add_subdirectory ( utils )
add_subdirectory ( docs )

# CPack support 
set ( CPACK_PACKAGE_DESCRIPTION_SUMMARY "libInstPatch instrument editing library" )
set ( CPACK_PACKAGE_VENDOR "swami.sourceforge.net" )
set ( CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md" )
set ( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING" )
set ( CPACK_PACKAGE_VERSION_MAJOR ${IPATCH_VERSION_MAJOR} )
set ( CPACK_PACKAGE_VERSION_MINOR ${IPATCH_VERSION_MINOR} )
set ( CPACK_PACKAGE_VERSION_PATCH ${IPATCH_VERSION_MICRO} )

# source packages
set ( CPACK_SOURCE_GENERATOR TGZ;TBZ2;ZIP )
set ( CPACK_SOURCE_IGNORE_FILES "/.svn/;~$;.cproject;.project;/.settings/;${CPACK_SOURCE_IGNORE_FILES}" )
set ( CPACK_SOURCE_PACKAGE_FILE_NAME "${PACKAGE}-${VERSION}" ) 
set ( CPACK_SOURCE_STRIP_FILES OFF )

# binary packages
include ( InstallRequiredSystemLibraries )
set ( CPACK_GENERATOR STGZ;TGZ;TBZ2;ZIP )
set ( CPACK_PACKAGE_NAME ${PACKAGE} )
set ( CPACK_STRIP_FILES ON )

include ( CPack )

message ( "Build options:" )

if ( ENABLE_DEBUG )
  message ( "Debug:                 yes" )
else ( ENABLE_DEBUG )
  message ( "Debug:                 no" )
endif ( ENABLE_DEBUG )

if (INTROSPECTION_FOUND)
  message ( "GObjectIntrospection:  yes" ) 
else (INTROSPECTION_FOUND)
  message ( "GObjectIntrospection:  no" ) 
endif(INTROSPECTION_FOUND)

if (GTKDOC_FOUND)
  message ( "Gtk-Doc API reference: yes" ) 
else (GTKDOC_FOUND)
  message ( "Gtk-Doc API reference: no" ) 
endif(GTKDOC_FOUND)

file(GLOB_RECURSE
     ALL_SOURCE_FILES
     LIST_DIRECTORIES false
     ${CMAKE_SOURCE_DIR}/*.[chi]
     ${CMAKE_SOURCE_DIR}/*.[chi]pp
     ${CMAKE_SOURCE_DIR}/*.[chi]xx
     ${CMAKE_SOURCE_DIR}/*.cc
     ${CMAKE_SOURCE_DIR}/*.hh
     ${CMAKE_SOURCE_DIR}/*.ii
     ${CMAKE_SOURCE_DIR}/*.[CHI]
     )
     
find_program ( ASTYLE "astyle" )
if ( ASTYLE )
  add_custom_target(
    format
    COMMAND ${ASTYLE}
    -A1
    -xb
    -j
    -k3
    -p
    -f
    -n
    -U
    ${ALL_SOURCE_FILES}
    )
endif ( ASTYLE)

=== libinstpatch/CMakeLists.txt ===
# 
# libInstPatch
#
# Copyright (C) 1999-2014 Element Green <element@elementsofsound.org>
#
# See COPYING license file for distribution details
#

include_directories (
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${GOBJECT_INCLUDEDIR}
    ${GOBJECT_INCLUDE_DIRS}
    ${SNDFILE_INCLUDEDIR}
    ${SNDFILE_INCLUDE_DIRS}
)

# ************ library ************

set ( instpatch_public_HEADERS
    builtin_enums.h
	compat.h
    IpatchBase.h
    IpatchContainer.h
    IpatchConverter.h
    IpatchConverterSF2VoiceCache.h
    IpatchConvert_DLS2.h
    IpatchConvert_Gig.h
    IpatchConvert_SF2.h
    IpatchConvert_SLI.h
    IpatchDLS2Conn.h
    IpatchDLS2.h
    IpatchDLS2Info.h
    IpatchDLS2Inst.h
    IpatchDLS2Region.h
    IpatchDLS2Sample.h
    IpatchDLSFile.h
    IpatchDLSReader.h
    IpatchDLSWriter.h
    IpatchFile.h
    IpatchGig.h
    IpatchGigDimension.h
    IpatchGigEffects.h
    IpatchGigFile.h
    IpatchGigInst.h
    IpatchGigRegion.h
    IpatchGigSample.h
    IpatchGigSubRegion.h
    IpatchItem.h
    IpatchIter.h
    IpatchList.h
    IpatchParamProp.h
    IpatchPaste.h
    IpatchRange.h
    IpatchRiff.h
    IpatchSample.h
    IpatchSampleData.h
    IpatchSampleList.h
    IpatchSampleStore.h
    IpatchSampleStoreCache.h
    IpatchSampleStoreFile.h
    IpatchSampleStoreRam.h
    IpatchSampleStoreRom.h
    IpatchSampleStoreSndFile.h
    IpatchSampleStoreSplit24.h
    IpatchSampleStoreSwap.h
    IpatchSampleStoreVirtual.h
    IpatchSampleTransform.h
    IpatchSF2.h
    IpatchSF2File.h
    IpatchSF2Gen.h
    IpatchSF2GenItem.h
    IpatchSF2Inst.h
    IpatchSF2IZone.h
    IpatchSF2Mod.h
    IpatchSF2ModItem.h
    IpatchSF2ModList.h
    IpatchSF2Preset.h
    IpatchSF2PZone.h
    IpatchSF2Reader.h
    IpatchSF2Sample.h
    IpatchSF2VoiceCache.h
    IpatchSF2VoiceCache_DLS.h
    IpatchSF2VoiceCache_SF2.h
    IpatchSF2VoiceCache_SLI.h
    IpatchSF2VoiceCache_Gig.h
    IpatchSF2VoiceCache_VBank.h
    IpatchSF2Writer.h
    IpatchSF2Zone.h
    IpatchSLI.h
    IpatchSLIFile.h
    IpatchSLIInst.h
    IpatchSLIReader.h
    IpatchSLISample.h
    IpatchSLIWriter.h
    IpatchSLIZone.h
    IpatchSndFile.h
    IpatchTypeProp.h
    IpatchUnit.h
    IpatchUnit_generic.h
    IpatchUnit_DLS.h
    IpatchUnit_SF2.h
    IpatchVBank.h
    IpatchVBankInst.h
    IpatchVBankRegion.h
    IpatchVirtualContainer.h
    IpatchVirtualContainer_types.h
    IpatchXml.h
    IpatchXmlObject.h
    misc.h
    sample.h
    util.h
) 

set ( instpatch_private_HEADERS
    IpatchDLSFile_priv.h
    IpatchGigFile_priv.h
    IpatchSF2File_priv.h
    IpatchSLIFile_priv.h
    compat.h
)

set ( instpatch_SOURCES
    builtin_enums.c
    IpatchBase.c
    IpatchContainer.c
    IpatchContainer_notify.c
    IpatchConverter.c
    IpatchConverterSF2VoiceCache.c
    IpatchConverter_priv.h
    IpatchConvert_DLS2.c
    IpatchConvert_Gig.c
    IpatchConvert_SF2.c
    IpatchConvert_SLI.c
    IpatchDLS2.c
    IpatchDLS2Conn.c
    IpatchDLS2Info.c
    IpatchDLS2Inst.c
    IpatchDLS2Region.c
    IpatchDLS2Sample.c
    IpatchDLSFile.c
    IpatchDLSReader.c
    IpatchDLSWriter.c
    IpatchFile.c
    IpatchFileBuf.c
    IpatchGig.c
    IpatchGigDimension.c
    IpatchGigEffects.c
    IpatchGigFile.c
    IpatchGigInst.c
    IpatchGigRegion.c
    IpatchGigSample.c
    IpatchGigSubRegion.c
    IpatchItem.c
    IpatchItemProp.c
    IpatchIter.c
    IpatchList.c
    IpatchParamProp.c
    IpatchPaste.c
    IpatchRange.c
    IpatchRiff.c
    IpatchSample.c
    IpatchSampleData.c
    IpatchSampleList.c
    IpatchSampleStore.c
    IpatchSampleStoreCache.c
    IpatchSampleStoreFile.c
    IpatchSampleStoreRam.c
    IpatchSampleStoreRom.c
    IpatchSampleStoreSndFile.c
    IpatchSampleStoreSplit24.c
    IpatchSampleStoreSwap.c
    IpatchSampleStoreVirtual.c
    IpatchSampleTransform.c
    IpatchSF2.c
    IpatchSF2File.c
    IpatchSF2Gen.c
    IpatchSF2GenItem.c
    IpatchSF2Gen_tables.c
    IpatchSF2Inst.c
    IpatchSF2IZone.c
    IpatchSF2Mod.c
    IpatchSF2ModItem.c
    IpatchSF2ModList.c
    IpatchSF2Preset.c
    IpatchSF2PZone.c
    IpatchSF2Reader.c
    IpatchSF2Sample.c
    IpatchSF2VoiceCache.c
    IpatchSF2VoiceCache_DLS.c
    IpatchSF2VoiceCache_SF2.c
    IpatchSF2VoiceCache_SLI.c
    IpatchSF2VoiceCache_Gig.c
    IpatchSF2VoiceCache_VBank.c
    IpatchSF2Writer.c
    IpatchSF2Zone.c
    IpatchSLI.c
    IpatchSLIFile.c
    IpatchSLIInst.c
    IpatchSLIInst_CatMaps.c
    IpatchSLIReader.c
    IpatchSLISample.c
    IpatchSLIWriter.c
    IpatchSLIZone.c
    IpatchSndFile.c
    IpatchTypeProp.c
    IpatchUnit.c
    IpatchUnit_generic.c
    IpatchUnit_DLS.c
    IpatchUnit_SF2.c
    IpatchVBank.c
    IpatchVBankInst.c
    IpatchVBankRegion.c
    IpatchVirtualContainer.c
    IpatchVirtualContainer_types.c
    IpatchXml.c
    IpatchXmlObject.c
    compat.c
    i18n.h
    md5.c
    md5.h
    misc.c
    sample.c
    util.c
)


set ( public_main_HEADER ${CMAKE_CURRENT_BINARY_DIR}/libinstpatch.h )

link_directories (
    ${GOBJECT_LIBDIR}
    ${GOBJECT_LIBRARY_DIRS}
    ${SNDFILE_LIBDIR}
    ${SNDFILE_LIBRARY_DIRS}
)

add_definitions ( -DLOCALEDIR="${CMAKE_INSTALL_LOCALEDIR}" )


set (DEFINITION_FILE "")
# Options for WINDOWS only
if( WIN32 )
    # disable deprecation warnings 
    add_definitions ( -D_CRT_SECURE_NO_WARNINGS )
    if (BUILD_SHARED_LIBS)
        # adding a module definition file for shared libs will export symbols and produce import library
        set (DEFINITION_FILE libinstpatch.def)
    endif(BUILD_SHARED_LIBS)
endif( WIN32 )

add_library ( libinstpatch
    ${CMAKE_CURRENT_BINARY_DIR}/marshals.c
    ${CMAKE_CURRENT_BINARY_DIR}/version.h
    ${instpatch_SOURCES} ${DEFINITION_FILE}
        ipatch_priv.h
)

target_link_libraries ( libinstpatch
    ${GOBJECT_LIBRARIES}
    ${SNDFILE_LIBRARIES}
    ${IPATCH_LIBS}
)

install ( FILES
          ${instpatch_public_HEADERS}
          ${public_main_HEADER}
          ${CMAKE_CURRENT_BINARY_DIR}/version.h
         DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${INSTPATCH_INSTALL_TARGET}/libinstpatch)

find_program (GLIB2_MKENUMS glib-mkenums)
find_program (SED sed)

add_custom_target(enums
  COMMAND ${GLIB2_MKENUMS}
    --fhead \"\#ifndef __IPATCH_BUILTIN_ENUMS_H__\\n\"
    --fhead \"\#define __IPATCH_BUILTIN_ENUMS_H__\\n\\n\"
    --fhead \"\#include <glib-object.h>\\n\\n\"
    --fhead \"G_BEGIN_DECLS\\n\"
    --fprod \"/* enumerations from \\"@filename@\\" */\\n\"
    --vhead \"GType @enum_name@_get_type \(void\)\;\\n\"
    --vhead \"\#define IPATCH_TYPE_@ENUMSHORT@ \(@enum_name@_get_type\(\)\)\\n\"
    --ftail \"G_END_DECLS\\n\\n\"
    --ftail \"\#endif /* __IPATCH_BUILTIN_ENUMS_H__ */\"
    ${instpatch_public_HEADERS}
    | ${SED} 's/dl_s2/dls2/g\;s/DL_S2/DLS2/g'
    > ${CMAKE_CURRENT_BINARY_DIR}/builtin_enums.h
    
  COMMAND ${GLIB2_MKENUMS}
    --fhead \"\#include \\"libinstpatch.h\\"\\n\"
    --fhead \"\#include \\"ipatch_priv.h\\"\\n\\n\"
    --fprod \"/* enumerations from \\"@filename@\\" */\"
    --vhead \"static const G@Type@Value _@enum_name@_values[] = {\"
    --vprod \"  { @VALUENAME@, \\"@VALUENAME@\\", \\"@valuenick@\\" },\"
    --vtail \"  { 0, NULL, NULL }\\n}\;\\n\\n\"
    --vtail \"GType\\n@enum_name@_get_type \(void\)\\n{\\n\"
    --vtail \"  static GType type = 0\;\\n\\n\"
    --vtail \"  if \(G_UNLIKELY \(type == 0\)\)\\n\"
    --vtail \"    type = g_\@type\@_register_static \(\\"@EnumName@\\", _@enum_name@_values\)\;\\n\\n\"
    --vtail \"  return type\;\\n}\\n\\n\"
    ${instpatch_public_HEADERS}
    | ${SED} 's/dl_s2/dls2/g\;s/DL_S2/DLS2/g'
    > ${CMAKE_CURRENT_BINARY_DIR}/builtin_enums.c
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${instpatch_public_HEADERS}
)

find_program (GLIB2_GENMARSHAL glib-genmarshal)

add_custom_command (
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/marshals.c
  COMMAND ${GLIB2_GENMARSHAL}
  ARGS
    --body --prefix=ipatch_marshal
    ${CMAKE_CURRENT_SOURCE_DIR}/marshals.list > ${CMAKE_CURRENT_BINARY_DIR}/marshals.c
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/marshals.list ${CMAKE_CURRENT_BINARY_DIR}/marshals.h
)

add_custom_command (
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/marshals.h
  COMMAND ${GLIB2_GENMARSHAL}
  ARGS
    --header --prefix=ipatch_marshal
    ${CMAKE_CURRENT_SOURCE_DIR}/marshals.list > ${CMAKE_CURRENT_BINARY_DIR}/marshals.h
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/marshals.list
)

if ( MACOSX_FRAMEWORK )
     set_property ( SOURCE ${instpatch_public_HEADERS} 
         PROPERTY MACOSX_PACKAGE_LOCATION Headers/libinstpatch
     )
    set_target_properties ( libinstpatch
      PROPERTIES
        OUTPUT_NAME "libinstpatch-1.0"
        FRAMEWORK TRUE
        PUBLIC_HEADER "${public_main_HEADER}"
        FRAMEWORK_VERSION "${LIB_VERSION_CURRENT}"
        INSTALL_NAME_DIR ${FRAMEWORK_INSTALL_DIR}
        VERSION ${LIB_VERSION_INFO}
        SOVERSION ${LIB_VERSION_CURRENT}
    )
elseif( MINGW OR WIN32 )
  set_target_properties ( libinstpatch
    PROPERTIES
      ARCHIVE_OUTPUT_NAME "instpatch-${LIB_VERSION_CURRENT}"
      PREFIX "lib"
      OUTPUT_NAME "instpatch-${LIB_VERSION_CURRENT}"
      VERSION ${LIB_VERSION_INFO}
  )
else( MINGW OR WIN32 )
  set_target_properties ( libinstpatch
    PROPERTIES
      OUTPUT_NAME "instpatch-1.0"
      VERSION ${LIB_VERSION_INFO}
      SOVERSION ${LIB_VERSION_CURRENT}
  )
endif ( MACOSX_FRAMEWORK )

if ( IPATCH_CPPFLAGS )
  set_target_properties ( libinstpatch
    PROPERTIES COMPILE_FLAGS ${IPATCH_CPPFLAGS} )
endif ( IPATCH_CPPFLAGS ) 

install ( TARGETS libinstpatch
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  FRAMEWORK DESTINATION ${FRAMEWORK_INSTALL_DIR}
  BUNDLE DESTINATION ${BUNDLE_INSTALL_DIR}
)

if ( MSVC )
  install(FILES $<TARGET_PDB_FILE:libinstpatch> DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
endif ( MSVC )

macro(_list_prefix _outvar _listvar _prefix)
  set(${_outvar})
  foreach(_item IN LISTS ${_listvar})
    list(APPEND ${_outvar} ${_prefix}${_item})
  endforeach()
endmacro(_list_prefix)

# GObject Introspection
if (INTROSPECTION_FOUND)

  # libInstPatch has to be initialized, so we build an introspection program which does this
  add_executable ( gir_prog gir_prog.c )

  target_link_libraries ( gir_prog
    libinstpatch
    ${GOBJECT_LIBRARIES}
    ${SNDFILE_LIBRARIES}
    ${IPATCH_LIBS}
    ${INTROSPECTION_LIBRARIES}
  )

  string (REPLACE ";" " " INTROSPECTION_CFLAGS_STR "${INTROSPECTION_CFLAGS}")
  set_target_properties (gir_prog
                         PROPERTIES COMPILE_FLAGS "${INTROSPECTION_CFLAGS_STR}")

  include(GObjectIntrospectionMacros)
  set(INTROSPECTION_GIRS)
  set(INTROSPECTION_SCANNER_ARGS "--add-include-path=${CMAKE_CURRENT_SOURCE_DIR}")
  set(INTROSPECTION_COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}")

  set(introspection_files ${instpatch_SOURCES} ${instpatch_public_HEADERS})
  set(Ipatch_1_1_gir ${INSTPATCH_INSTALL_TARGET})
  set(Ipatch_1_1_gir_INCLUDES GObject-2.0)
  set(Ipatch_1_1_gir_LIBS ${INSTPATCH_INSTALL_TARGET})
  get_directory_property(_tmp_includes INCLUDE_DIRECTORIES)
  _list_prefix(_includes _tmp_includes "-I")
  set(Ipatch_1_1_gir_CFLAGS ${_includes})
  set(Ipatch_1_1_gir_PROGRAM ${CMAKE_CURRENT_BINARY_DIR}/gir_prog)
  _list_prefix(_abs_introspection_files introspection_files "${CMAKE_CURRENT_SOURCE_DIR}/")
  list(APPEND _abs_introspection_files
    ${CMAKE_CURRENT_SOURCE_DIR}/builtin_enums.c
    ${CMAKE_CURRENT_SOURCE_DIR}/builtin_enums.h
    ${CMAKE_CURRENT_BINARY_DIR}/version.h
  )
  set(Ipatch_1_1_gir_NAMESPACE Ipatch)
  set(Ipatch_1_1_gir_VERSION 1.1)
  set(Ipatch_1_1_gir_FILES ${_abs_introspection_files})
  set(Ipatch_1_1_gir_SCANNERFLAGS --c-include ${public_main_HEADER})

  list(APPEND INTROSPECTION_GIRS Ipatch-1.1.gir)

  gir_add_introspections(INTROSPECTION_GIRS)

  add_dependencies (gir-girs gir_prog)  # Add introspection program as a dependency of gir-girs

=== utils/CMakeLists.txt ===
include_directories (
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${GLIB_INCLUDEDIR}
    ${GLIB_INCLUDE_DIRS}
    ${GOBJECT_INCLUDEDIR}
    ${GOBJECT_INCLUDE_DIRS}
    ${SNDFILE_INCLUDEDIR}
    ${SNDFILE_INCLUDE_DIRS}
)

if( WIN32 )
    # disable deprecation warnings 
    add_definitions ( -D_CRT_SECURE_NO_WARNINGS )
endif( WIN32 )

link_directories (
    ${GLIB_LIBDIR}
    ${GLIB_LIBRARY_DIRS}
    ${GOBJECT_LIBDIR}
    ${GOBJECT_LIBRARY_DIRS}
    ${SNDFILE_LIBDIR}
    ${SNDFILE_LIBRARY_DIRS}
)

add_executable ( riff_dump riff_dump.c )
add_dependencies( riff_dump libinstpatch )
target_link_libraries( riff_dump libinstpatch )

=== docs/reference/CMakeLists.txt ===
# 
# libInstPatch
#
# Copyright (C) 1999-2014 Element Green <element@elementsofsound.org>
#
# See COPYING license file for distribution details
#

set (ignore_headers
    IpatchConvert_Gig.h
    IpatchConvert_SF2.h
    IpatchConvert_DLS2.h
    IpatchConverter_priv.h
    IpatchSF2VoiceCache_DLS.h
    IpatchSF2VoiceCache_Gig.h
    IpatchSF2VoiceCache_SF2.h
    IpatchSF2VoiceCache_VBank.h
    IpatchState.h
    IpatchStateGroup.h
    IpatchStateItem.h
    IpatchState_types.h
    builtin_enums.h
    compat.h
    config.h
    i18n.h
    ipatch_priv.h
    libinstpatch.h
    marshals.h
)

if (GTKDOC_FOUND)
  gtk_doc_add_module (libinstpatch
    SOURCE ${CMAKE_SOURCE_DIR}/libinstpatch
    XML libinstpatch-docs.xml
    SUFFIXES c h
    IGNOREHEADERS ${ignore_headers}
    SCANOPTS ${CMAKE_CURRENT_BINARY_DIR}/../../libinstpatch/version.h
    SCANOBJOPTS --type-init-func=ipatch_init\(\)
    CFLAGS -I${CMAKE_SOURCE_DIR} -include libinstpatch/misc.h
    LDFLAGS -L${CMAKE_CURRENT_BINARY_DIR}/../../libinstpatch -linstpatch-1.0
    LDPATH ${CMAKE_CURRENT_BINARY_DIR}/../../libinstpatch
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/../../libinstpatch/libinstpatch-1.0.so
  )

  add_custom_target(documentation ALL DEPENDS doc-libinstpatch)
endif ()

=== debian/changelog ===
libinstpatch (1.1.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for build breakage in reverse dependencies.
    (Closes: #1117839)

 -- Adrian Bunk <bunk@debian.org>  Thu, 16 Oct 2025 15:51:52 +0300

libinstpatch (1.1.7-1) unstable; urgency=medium

  * New upstream version 1.1.7
    + Fix build with GCC-15 (Closes: #1097199)
    + Fix build with CMake 4 (Closes: #1113158)
  * Change my email address
  * Remove unnecessary constraints
  * Bump Standards-Version to 4.7.2

 -- Dennis Braun <snd@debian.org>  Sun, 28 Sep 2025 19:55:52 +0200

=== debian/control ===
Source: libinstpatch
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <snd@debian.org>,
 Alessio Treglia <alessio@debian.org>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 gettext,
 intltool,
 libglib2.0-dev,
 libsndfile1-dev
Rules-Requires-Root: no
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/multimedia-team/libinstpatch.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/libinstpatch
Homepage: https://github.com/swami/libinstpatch

Package: libinstpatch-1.0-2
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Description: MIDI instrument editing library
 libInstPatch stands for lib-Instrument-Patch and is a library for
 processing digital sample based MIDI instrument "patch" files.
 The types of files libInstPatch supports are used for creating
 instrument sounds for wavetable synthesis. This library provides
 an object framework (based on GObject) to load patch files into,
 which can then be edited, converted, compressed and saved.
 .
 More information can be found on the Project Swami website
 http://swami.sourceforge.net.
 .
 This package contains the shared library.

Package: libinstpatch-dev
Section: libdevel
Architecture: any
Depends:
 libglib2.0-dev,
 libinstpatch-1.0-2 (= ${binary:Version}),
 libsndfile1-dev,
 pkgconf,
 ${misc:Depends}
Multi-Arch: same
Description: MIDI instrument editing library development files
 libInstPatch stands for lib-Instrument-Patch and is a library for
 processing digital sample based MIDI instrument "patch" files.
 The types of files libInstPatch supports are used for creating
 instrument sounds for wavetable synthesis. This library provides
 an object framework (based on GObject) to load patch files into,
 which can then be edited, converted, compressed and saved.
 .
 More information can be found on the Project Swami website
 http://swami.sourceforge.net.
 .
 This package contains the headers and static library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	dh_install -plibinstpatch-dev usr/include
	dh_install -plibinstpatch-dev usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so
	dh_install -plibinstpatch-dev usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*
	dh_install -plibinstpatch-1.0-2 usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so.*
	dh_install --remaining-packages
